#include <sstream>
#include "Pathfinder.h"
#include "LcaTree.h"

class TreeCacheImproved: public Pathfinder {
public:
	void preprocess(std::vector<int> &map, int width, int height);
	void findPath(Position start, Position goal, std::vector<Position> &path,
			std::vector<int> &map, int width, int height);

	void clear(){
		trees.clear();
		distancesPerTree.clear();
	}

	std::string getName(){
		return name;
	}

	size_t getSize(){
		size_t size = 0;
		for(auto dists : distancesPerTree){
			size += dists.size();
		}
		size *= sizeof(double);
		for(LcaTree tree : trees){
			size += tree.getSize();
		}
		return size;
	}

	TreeCacheImproved(int nRoots) :
			nRoots(nRoots){
		std::stringstream stream;
		stream << "TreeCacheImproved" << nRoots;
		name = stream.str();
	}

private:

	std::vector<LcaTree> trees;
	std::vector<std::vector<double> > distancesPerTree;
	int nRoots;
	std::string name;
};
