#include <iostream>
#include "LcaTree.h"

#ifdef VISUAL
#include <intrin.h>
#pragma intrinsic(_BitScanReverse)
#endif

int main(int argc, char **argv){
	LcaTree tree(0, 8);
	tree.addNode(0, 1);
	tree.addNode(1, 2);
	tree.addNode(1, 3);
	tree.addNode(0, 4);
	tree.addNode(4, 5);
	tree.addNode(6, 7);

	tree.prepareLCA();

	std::cout << " 0:" << tree.getLCA(1, 5) << std::endl;
	std::cout << " 0:" << tree.getLCA(5, 2) << std::endl;
	std::cout << " 1:" << tree.getLCA(2, 3) << std::endl;
	std::cout << "-1:" << tree.getLCA(1, 6) << std::endl;

#ifndef VISUAL
	std::cout << log2(4) << ":" << 31 - __builtin_clz(4) << std::endl;
	std::cout << log2(8) << ":" << 31 - __builtin_clz(8) << std::endl;
	std::cout << log2(25) << ":" << 31 - __builtin_clz(25) << std::endl;
#else
	unsigned long index;
	_BitScanReverse(&index, 4);
	std::cout << log2(4) << ":" << index << std::endl;
	_BitScanReverse(&index, 8);
	std::cout << log2(8) << ":" << index << std::endl;
	_BitScanReverse(&index, 25);
	std::cout << log2(25) << ":" << index << std::endl;
#endif
}
